"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function connect() {
  return _connect.apply(this, arguments);
}

function _connect() {
  _connect = _asyncToGenerator(function* () {
    try {
      var _spice$config, _spice$config$cache;

      spice.cache_providers = {};
      spice.monitor = new Map();

      if ((_spice$config = spice.config) == null ? void 0 : (_spice$config$cache = _spice$config.cache) == null ? void 0 : _spice$config$cache.providers) {
        for (var key of Object.keys(((_spice$config$cache2 = spice.config.cache) == null ? void 0 : _spice$config$cache2.providers) || {})) {
          var _spice$config$cache2;

          spice.cache_providers[key] = new spice.config.cache.providers[key](spice.config.cache.drivers[key] || {});
          spice.cache_providers[key].initialize().then(() => {
            console.log("Redis initialized successfully");
          }).catch(err => {
            console.error("Error initializing Redis:", err);
          });
        }
      }
    } catch (e) {
      console.log(e.stack);
      throw e;
    }
  });
  return _connect.apply(this, arguments);
}

module.exports = connect;