"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

spice.database = {};
spice.database.connections = {};
spice.database.clusters = {};
spice.database.scopes = {};
spice.database.buckets = {};

function connect() {
  return _connect.apply(this, arguments);
}

function _connect() {
  _connect = _asyncToGenerator(function* () {
    try {
      for (var key in spice.config.database.connections) {
        var value = spice.config.database.connections[key];

        if (value.enabled) {
          var Database = require("spice-" + value.type);

          var connection = new Database();
          var result = yield connection.connect(key, value);
          spice.database.connections[result.connection] = result.collection;
          spice.database.clusters[result.connection] = result.cluster;
          spice.database.scopes[result.connection] = result.scope;
          spice.database.buckets[result.connection] = result.bucket;
        }
      }
    } catch (e) {
      console.log(e.stack);
      throw e;
    }
  });
  return _connect.apply(this, arguments);
}

module.exports = connect;