"use strict";

var _path = _interopRequireDefault(require("path"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EventEmitter = require("events");

class MyEmitter extends EventEmitter {}

var myEmitter = new MyEmitter();
spice.EventEmitter = myEmitter;

var eventingManifest = require(_path.default.resolve(_path.default.join(spice.root_path, "/eventing/manifest.js")));

_lodash.default.each(eventingManifest.default, entry => {
  var topic = new entry.event().topic;
  var Processor = spice.config.event.providers[new entry.event().driver || spice.config.event.default_driver];
  var processor = new Processor();

  _lodash.default.each(entry.handlers, handler => {
    processor.on(topic, new handler().handle);
  });
});