"use strict";

exports.__esModule = true;
exports.default = addTask;

var _path = _interopRequireDefault(require("path"));

var _agenda = _interopRequireDefault(require("agenda"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var agenda = null;
module.exports =
/*#__PURE__*/
_asyncToGenerator(function* () {
  if (spice.config.tasks.enabled) {
    agenda = new _agenda.default({
      db: {
        address: spice.config.tasks.address,
        collection: spice.config.tasks.collection
      }
    });
    yield agenda.start();
    yield agenda.purge();
    return new Promise(
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(function* (resolve, reject) {
        try {
          var locations = [spice.module_root_path + '/tasks', spice.root_path + '/tasks'];

          var _loop = function _loop(i) {
            var files = require('fs').readdirSync(i);

            files.forEach(
            /*#__PURE__*/
            function () {
              var _ref3 = _asyncToGenerator(function* (file) {
                file.split('.')[0];

                var task = require(_path.default.join(i, file));

                if (task.enabled) {
                  yield addTask(task);
                }
              });

              return function (_x3) {
                return _ref3.apply(this, arguments);
              };
            }());
          };

          for (var i of locations) {
            _loop(i);
          }

          resolve({});
        } catch (e) {
          reject(e);
        }
      });

      return function (_x, _x2) {
        return _ref2.apply(this, arguments);
      };
    }());
  }
});

function addTask(_x4, _x5) {
  return _addTask.apply(this, arguments);
}

function _addTask() {
  _addTask = _asyncToGenerator(function* (task, params) {
    if (params === void 0) {
      params = null;
    }

    agenda.define(task.name, task.handle);
    var parameters = params != null ? params : task.params;
    var returned_function = yield getExecuteFunction(task, parameters);

    if (task.schedule.repeat) {
      yield returned_function.job[returned_function.function](task.schedule.repeat_value, {
        skipImmediate: true
      }).save();
    } else {
      yield returned_function(task.schedule.repeat_value, task.name, parameters);
    } //await returned_function(task.schedule.repeat_value, task.name);

  });
  return _addTask.apply(this, arguments);
}

function getExecuteFunction(_x6, _x7) {
  return _getExecuteFunction.apply(this, arguments);
}

function _getExecuteFunction() {
  _getExecuteFunction = _asyncToGenerator(function* (task, params) {
    if (task.schedule.repeat) {
      var job = yield agenda.create(task.name, params);

      switch (task.schedule.repeat_type) {
        case "interval":
          {
            return {
              job,
              function: "repeatEvery"
            };
            break;
          }

        case "time":
          {
            return {
              job,
              function: "repeatAt"
            };
            break;
          }
      }
    }

    return agenda.schedule;
  });
  return _getExecuteFunction.apply(this, arguments);
}