"use strict";

var _koaStatic = _interopRequireDefault(require("koa-static"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by chadfraser on 05/02/2017.
 */
var views = require('koa-views');

var path = require("path");

var convert = require('koa-convert');

try {
  var nunjucksOptions = {
    map: {
      html: 'nunjucks'
    },
    options: {
      ext: spice.config.spice.view.ext || '.html',
      noCache: true,
      throwOnUndefined: false,
      globals: spice.config.spice.view.globals,
      filters: spice.config.spice.view.filters
    }
  };

  if (spice.config.spice.view.custom_tags.enabled == true) {
    nunjucksOptions.options.tags = {
      variableStart: spice.config.spice.view.custom_tags.start || '${',
      variableEnd: spice.config.spice.view.custom_tags.end || '}'
    };
  }

  spice.app.use(views(path.resolve('./src/views'), nunjucksOptions));
  spice.app.use(convert((0, _koaStatic.default)(path.resolve('./public'))));
} catch (e) {
  console.log(e, e.stack);
}