"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var NodeCache = require("node-cache");

module.exports = class SpiceCache {
  constructor(args) {
    if (args === void 0) {
      args = {};
    }

    this.options = args;
    this.client = null;
  }

  initialize(options) {
    var _this = this;

    return _asyncToGenerator(function* () {
      if (options === void 0) {
        options = {};
      }

      _this.options = _extends({}, _this.options, options);
      _this.client = new NodeCache();
    })();
  }

  set(key, value, options) {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      if (options === void 0) {
        options = {};
      }

      var working_options = _extends({}, _this2.options, options);

      var {
        ttl,
        namespace = ""
      } = working_options;
      if (value === undefined) return console.log("Value is undefined");

      _this2.client.set(namespace + key, value, ttl || 60);
    })();
  }

  get(key, options) {
    var _this3 = this;

    return _asyncToGenerator(function* () {
      if (options === void 0) {
        options = {};
      }

      try {
        return _this3.client.get(key);
      } catch (e) {
        return null;
      }
    })();
  }

  exists(key) {
    var _this4 = this;

    return _asyncToGenerator(function* () {
      return yield _this4.client.exists(key);
    })();
  }

};