"use strict";

exports.__esModule = true;
exports.load = load;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var ordered_modules = ["schema_extenders", "database", "map", "logger", "error"];
var last_modules = ["views", "routes"];

function load() {
  return _load.apply(this, arguments);
} //load();


function _load() {
  _load = _asyncToGenerator(function* () {
    try {
      /* console.log('loading from array')*/
      var bootstrap_path = _path.default.resolve(_path.default.join(spice.module_root_path, "/bootstrap"));

      var app_bootstrap_path = _path.default.resolve(_path.default.join(spice.root_path, "/bootstrap"));
      /* console.log('MODULE Bootstrap directory', bootstrap_path);
          console.log('APP Bootstrap directory', app_bootstrap_path); */


      console.log("Loading Ordered Files", ordered_modules);

      for (var file of ordered_modules) {
        var mod = require(_path.default.join(bootstrap_path, file));

        if (_lodash.default.isFunction(mod)) {
          yield mod();
        }

        console.log("loaded", file);
      }

      var paths = [bootstrap_path, app_bootstrap_path];

      for (var loadder_path of paths) {
        for (var _file of _fs.default.readdirSync(loadder_path)) {
          console.log("Loading:", _file);

          if (_file != "index.js" && !_lodash.default.includes(ordered_modules, _file.split(".")[0]) && !_lodash.default.includes(last_modules, _file.split(".")[0])) {
            var _mod = require(_path.default.join(loadder_path, _file.split(".")[0]));

            if (_lodash.default.isFunction(_mod)) {
              yield _mod();
            }
          }
        }
      }

      for (var _file2 of last_modules) {
        var _mod2 = require(_path.default.join(bootstrap_path, _file2));

        if (_lodash.default.isFunction(_mod2)) {
          yield _mod2();
        }

        console.log("loaded", _file2);
      }
    } catch (e) {
      console.log(e.stack);
    }
  });
  return _load.apply(this, arguments);
}