"use strict";

exports.__esModule = true;
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var views = require("koa-views");

var path = require("path");

var juice = require("juice");

class Mail {
  constructor(args) {
    if (args === void 0) {
      args = {};
    }

    this.nunjucksOptions = {
      map: {
        html: "nunjucks"
      },
      options: {
        ext: spice.config.spice.view.ext || ".html",
        noCache: true,
        throwOnUndefined: false,
        globals: spice.config.spice.view.globals,
        filters: spice.config.spice.view.filters
      }
    };

    if (spice.config.spice.view.custom_tags.enabled == true) {
      this.nunjucksOptions.options.tags = {
        variableStart: spice.config.spice.view.custom_tags.start || "${",
        variableEnd: spice.config.spice.view.custom_tags.end || "}"
      };
    }

    this.driver_name = args.driver_name || spice.config.mail.default_driver;
    this.driver_options = _lodash.default.merge(spice.config.mail.drivers[this.driver_name], args.driver_options);
    this.template = args.template;
    this.Driver = spice.config.mail.providers[this.driver_name];
  }

  prepare(data) {
    var _this = this;

    return _asyncToGenerator(function* () {
      //apply template here
      var obj = {
        response: {}
      };
      views(path.resolve("./src/views"), _this.nunjucksOptions)(obj, () => {});
      yield obj.render(_this.template, data);
      return obj.body;
    })();
  }

  send(_ref) {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      var {
        data,
        options,
        template,
        content,
        driver_options
      } = _ref;

      if (template) {
        _this2.template = template;
      }

      if (driver_options) {
        _this2.driver_options = _lodash.default.merge(_this2.driver_options, driver_options);
      }

      var sendable_text = "";

      if (_this2.template) {
        sendable_text = yield _this2.prepare(_extends({}, data, _this2));
      }

      if (content) {
        sendable_text = content;
      }

      var driver = new _this2.Driver(_this2.driver_options);
      return yield driver.send(juice(sendable_text), options);
    })();
  }

}

exports.default = Mail;