"use strict";

exports.__esModule = true;
exports.default = void 0;

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var fs = require('fs-extra');

var path = require('path');

var open = require("open");

class File {
  constructor(args) {
    if (args === void 0) {
      args = {};
    }

    this.sender = args.sender;
    this.subject = args.subject;
    this.htmlText = args.htmlText;
    this.dest = path.join(path.resolve('./'), 'storage/mail');

    if (args.path) {
      this.dest = path.resolve(args.path);
    }
  }

  send(htmlText, options) {
    var _this = this;

    return _asyncToGenerator(function* () {
      if (options === void 0) {
        options = {};
      }

      var email = {
        to: options.to,
        from: options.sender || _this.sender,
        subject: options.subject || _this.subject,
        htmlText: htmlText || _this.htmlText
      };
      var time = new Date().getTime();
      fs.ensureDirSync(_this.dest + "/" + email.subject + "/" + time);
      var full_path = _this.dest + "/" + email.subject + "/" + time + "/to:" + email.to + " from:" + email.from + ".html";
      fs.writeFileSync(full_path, email.htmlText);
      open(full_path);
    })();
  }

}

exports.default = File;