"use strict";

exports.__esModule = true;
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var views = require("koa-views");

var path = require("path");

var juice = require("juice");

class Storage {
  constructor(args) {
    if (args === void 0) {
      args = {};
    }

    this.driver_name = args.driver_name || spice.config.storage.default_driver;
    this.driver_options = _lodash.default.merge(spice.config.storage.drivers[this.driver_name], args.options); //console.log(this.driver_name, spice.config.storage.providers)

    this.Driver = spice.config.storage.providers[this.driver_name];
  }

  save(_ref) {
    var _this = this;

    return _asyncToGenerator(function* () {
      var {
        files,
        path,
        options
      } = _ref;

      if (options) {
        _this.driver_options = _lodash.default.merge(_this.driver_options, options);
      } //console.log(this.Driver);


      var driver = new _this.Driver(_this.driver_options);
      return yield driver.save({
        files,
        path: _this.driver_options.base_path ? _this.driver_options.base_path + "/" + path : path
      });
    })();
  }

  download(_ref2) {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      var {
        file,
        bucket,
        options
      } = _ref2;

      if (options) {
        _this2.driver_options = _lodash.default.merge(_this2.driver_options, options);
      }

      var driver = new _this2.Driver(_this2.driver_options);
      return yield driver.download({
        file,
        bucket
      });
    })();
  }

}

exports.default = Storage;