"use strict";

exports.__esModule = true;
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var fs = require('fs-extra');

var path = require('path');

var open = require("open");

var uuid = require('uuid');

class Local {
  constructor(args) {
    if (args === void 0) {
      args = {};
    }

    this.args = args;
  }

  save(_ref) {
    return _asyncToGenerator(function* () {
      var {
        files,
        path
      } = _ref;

      if (_lodash.default.has(files, 'path') && _lodash.default.has(files, 'size') && _lodash.default.has(files, '_writeStream')) {
        files = {
          files
        };
      }

      files = _lodash.default.reduce(_lodash.default.map(_lodash.default.values(files), file => {
        if (!_lodash.default.isArray(file)) {
          return Array.of(file);
        }

        return file;
      }), (accu, item) => {
        return [...accu, ...item];
      }, []);

      function makeDirectory(dir) {
        if (!fs.existsSync(dir)) {
          fs.mkdirSync(dir);
        }
      } // Create folders 


      var pathArray = path.split('/');

      _lodash.default.reduce(pathArray, (accu, item) => {
        if (item != accu) {
          accu = _lodash.default.join([accu, item], '/');
        }

        makeDirectory(accu);
        return accu;
      }, pathArray[0]); // Create read stream


      var readStreams = _lodash.default.map(files, file => {
        return {
          file,
          readStream: fs.createReadStream(file.path)
        };
      }); // Create Write Stream


      ;

      var paths = _lodash.default.map(readStreams, item => {
        var extension = _lodash.default.last(item.file.name.split("."));

        var file_name = _lodash.default.last(uuid.v4().split("-"));

        var writeStream = fs.createWriteStream(path + "/" + file_name + "." + extension);
        item.readStream.pipe(writeStream);
        item.readStream.on("end", function (err) {
          fs.unlink(item.file.path, function (obj) {});
        });
        return path + "/" + file_name + "." + extension;
      });

      if (paths.length == 1) {
        return _lodash.default.first(paths);
      }

      return paths;
    })();
  }

  delete(_ref2) {
    var _this = this;

    return _asyncToGenerator(function* () {
      var {
        path
      } = _ref2;
      console.log("Sending", _this.args, path);
    })();
  }

}

exports.default = Local;