"use strict";
/**
 * Created by chadfraser on 12/12/15.
 */

exports.__esModule = true;
exports.default = void 0;

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var crypto = require("crypto");

class Crypt {
  constructor() {
    this.salt = "";
    this.hash = "";
  }

  encrypt(value) {
    var _this = this;

    return _asyncToGenerator(function* () {
      var that = _this;
      return new Promise(
      /*#__PURE__*/
      function () {
        var _ref = _asyncToGenerator(function* (resolve, reject) {
          try {
            if (!value) {
              reject(new Error('Value must not be empty'));
            }

            var salt = yield that.generateRandumString(128);
            var hash_obj = yield that.findHash(value, salt);
            resolve(hash_obj);
          } catch (e) {
            reject(e);
          }
        });

        return function (_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }());
    })();
  }

  generateRandumString(length) {
    return _asyncToGenerator(function* () {
      return new Promise(
      /*#__PURE__*/
      function () {
        var _ref2 = _asyncToGenerator(function* (resolve, reject) {
          if (!length) {
            length = 64;
          }

          crypto.randomBytes(length, function (err, bytes) {
            if (err) {
              reject(err);
            }

            var ran_bytes = new Buffer(bytes).toString('hex');
            resolve(ran_bytes);
          });
        });

        return function (_x3, _x4) {
          return _ref2.apply(this, arguments);
        };
      }());
    })();
  }

  findHash(value, salt) {
    return _asyncToGenerator(function* () {
      try {
        return new Promise(
        /*#__PURE__*/
        function () {
          var _ref3 = _asyncToGenerator(function* (resolve, reject) {
            crypto.pbkdf2(value, salt, 7000, 256, 'sha512', (err, hash) => {
              if (err) {
                reject(err);
              }

              var object = {};
              object.hash = new Buffer(hash).toString('hex');
              object.salt = salt;
              resolve(object);
            });
          });

          return function (_x5, _x6) {
            return _ref3.apply(this, arguments);
          };
        }());
      } catch (e) {
        return Promise.reject(e);
      }
    })();
  }

}

exports.default = Crypt;