"use strict";

var Rules = spice.classes.validate.Rules;

Rules.prototype.shouldExist = function* (field, value, args, message) {
  try {
    var loaded = require(spice.root_path + ("/models/" + args));

    var Class = loaded.default;
    var obj = new Class();
    var found = yield obj.exist(value);

    if (found) {
      return true;
    }
  } catch (e) {
    this.validator.addError(field, 'rule', field + 'ShouldExist', 'Cannot Validate ' + args);
  }

  return false;
};

Rules.prototype.unique = function* (field, value, args, message) {
  try {
    var loaded = require(spice.root_path + ("/models/" + args[0]));

    var Class = loaded.default;
    var obj = new Class();
    var found = yield obj.list({
      query: args[1] + " = \"" + value + "\""
    });

    if (found.data.length == 0) {
      return true;
    } else {
      this.validator.addError(field, 'rule', field + ' should be unique', 'Cannot Validate ' + args[0]);
    }
  } catch (e) {
    this.validator.addError(field, 'rule', field + ' should be unique', 'Cannot Validate ' + args[0]);
  }

  return false;
};