var gulp = require("gulp");
var babel = require("gulp-babel");
var paths = {};
paths.src = "./src/**/*.js";

gulp.task("build_spice", () =>
  gulp
    .src(paths.src)
    .pipe(
      babel({
        presets: [
          [
            "@babel/preset-env",
            {
              loose: true,
              targets: {
                esmodules: true,
                node: "current",
              },
            },
          ],
        ],
        plugins: [
          ["@babel/plugin-proposal-class-properties", { loose: true }],
          ["@babel/plugin-proposal-export-namespace-from", { loose: true }],
          ["@babel/plugin-proposal-export-default-from", { loose: true }],
        ],
      })
    )
    .pipe(gulp.dest("build"))
);

// Default task
gulp.task("default", gulp.series("build_spice"));
gulp.task("watch", function () {
  gulp.watch(paths.src, gulp.series("build_spice"));
});
