"use strict";

async function connect() {
  try {
    spice.cache_providers = {};
    spice.monitor = new Map();
    if (spice.config?.cache?.providers) {
      for (let key of Object.keys(spice.config.cache?.providers || {})) {
        spice.cache_providers[key] = new spice.config.cache.providers[key](
          spice.config.cache.drivers[key] || {}
        );
        spice.cache_providers[key]
          .initialize()
          .then(() => {
            console.log("Redis initialized successfully");
          })
          .catch((err) => {
            console.error("Error initializing Redis:", err);
          });
      }
    }
  } catch (e) {
    console.log(e.stack);
    throw e;
  }
}
module.exports = connect;
