"use strict";

spice.database = {};
spice.database.connections = {};
spice.database.clusters = {};
spice.database.scopes = {};
spice.database.buckets = {};

async function connect() {
  try {
    for (let key in spice.config.database.connections) {
      let value = spice.config.database.connections[key];
      if (value.enabled) {
        let Database = require(`spice-${value.type}`);
        let connection = new Database();
        let result = await connection.connect(key, value);
        spice.database.connections[result.connection] = result.collection;
        spice.database.clusters[result.connection] = result.cluster;
        spice.database.scopes[result.connection] = result.scope;
        spice.database.buckets[result.connection] = result.bucket;
      }
    }
  } catch (e) {
    console.log(e.stack);
    throw e;
  }
}
module.exports = connect;
