import path from "path";
import _ from "lodash";
try {
  let resources = ["models", "controllers", "schemas", "cache"];
  _.each(resources, async function (resource) {
    let paths = path.join(spice.root_path, resource);
    spice[resource] = {};
    for (let file of require("fs").readdirSync(paths)) {
      let file_name = file.split(".")[0];
      spice[resource][file_name.toLowerCase()] = (
        await import(path.join(paths, file))
      ).default;
      spice[resource][file_name] = (
        await import(path.join(paths, file))
      ).default;
      if (resource == "models") {
        new spice[resource][file_name]({});
      }
    }
  });
} catch (error) {
  console.log("Error Happened", error);
}
