/**
 * Created by chadfraser on 25/02/2017.
 */
import path from 'path';
import Agenda from "agenda"
var agenda = null;
module.exports = async function () {
    if (spice.config.tasks.enabled) {
        agenda = new Agenda({ db: { address: spice.config.tasks.address, collection: spice.config.tasks.collection } });

        await agenda.start();
        await agenda.purge();
        return new Promise(async function (resolve, reject) {
            try {
                let locations = [spice.module_root_path + '/tasks', spice.root_path + '/tasks']

                for (let i of locations) {
                    let files = require('fs').readdirSync(i);
                    files.forEach(async function (file) {

                        file.split('.')[0];
                        let task = require(path.join(i, file));
                        if (task.enabled) {
                            await addTask(task);
                        }
                    });
                }
                resolve({})
            } catch (e) {
                reject(e);
            }
        });

    }


}

export default async function addTask(task, params = null) {
    agenda.define(task.name, task.handle);
    let parameters = params != null ? params : task.params;
    let returned_function = await getExecuteFunction(task, parameters)

    if (task.schedule.repeat) {
        await returned_function.job[returned_function.function](task.schedule.repeat_value, {
            skipImmediate: true
        }).save();
    } else {
        await returned_function(task.schedule.repeat_value, task.name, parameters);
    }
    //await returned_function(task.schedule.repeat_value, task.name);
}

async function getExecuteFunction(task, params) {
    if (task.schedule.repeat) {

        var job = await agenda.create(task.name, params)
        switch (task.schedule.repeat_type) {
            case "interval": {
                return { job, function: "repeatEvery" };
                break;
            }
            case "time": {
                return { job, function: "repeatAt" };
                break;
            }
        }
    }
    return agenda.schedule;

}