const NodeCache = require("node-cache");
module.exports = class SpiceCache {
  constructor(args = {}) {
    this.options = args;
    this.client = null;
  }
  async initialize(options = {}) {
    this.options = { ...this.options, ...options };
    this.client = new NodeCache();
  }

  async set(key, value, options = {}) {
    let working_options = { ...this.options, ...options };
    const { ttl, namespace = "" } = working_options;
    if (value === undefined) return console.log("Value is undefined");
    this.client.set(namespace + key, value, ttl || 60);
  }

  async get(key, options = {}) {
    try {
      return this.client.get(key);
    } catch (e) {
      return null;
    }
  }

  async exists(key) {
    return await this.client.exists(key);
  }
};
