import path from "path";
import fs from "fs";
import _ from "lodash";

let ordered_modules = [
  "schema_extenders",
  "database",
  "map",
  "logger",
  "error",
];
let last_modules = ["views", "routes"];
export async function load() {
  try {
    /* console.log('loading from array')*/

    let bootstrap_path = path.resolve(
      path.join(spice.module_root_path, "/bootstrap")
    );

    let app_bootstrap_path = path.resolve(
      path.join(spice.root_path, "/bootstrap")
    );

    /* console.log('MODULE Bootstrap directory', bootstrap_path);
        console.log('APP Bootstrap directory', app_bootstrap_path); */
    console.log("Loading Ordered Files", ordered_modules);
    for (let file of ordered_modules) {
      let mod = require(path.join(bootstrap_path, file));
      if (_.isFunction(mod)) {
        await mod();
      }
      console.log("loaded", file);
    }

    let paths = [bootstrap_path, app_bootstrap_path];

    for (let loadder_path of paths) {
      for (let file of fs.readdirSync(loadder_path)) {
        console.log("Loading:", file);
        if (
          file != "index.js" &&
          !_.includes(ordered_modules, file.split(".")[0]) &&
          !_.includes(last_modules, file.split(".")[0])
        ) {
          let mod = require(path.join(loadder_path, file.split(".")[0]));
          if (_.isFunction(mod)) {
            await mod();
          }
        }
      }
    }

    for (let file of last_modules) {
      let mod = require(path.join(bootstrap_path, file));
      if (_.isFunction(mod)) {
        await mod();
      }
      console.log("loaded", file);
    }
  } catch (e) {
    console.log(e.stack);
  }
}
//load();
