var views = require("koa-views");
const path = require("path");
const juice = require("juice");
import _ from "lodash";

export default class Storage {
  constructor(args = {}) {
    this.driver_name = args.driver_name || spice.config.storage.default_driver;
    this.driver_options = _.merge(
      spice.config.storage.drivers[this.driver_name],
      args.options
    );
    //console.log(this.driver_name, spice.config.storage.providers)
    this.Driver = spice.config.storage.providers[this.driver_name];
  }

  async save({ files, path, options }) {
    if (options) {
      this.driver_options = _.merge(this.driver_options, options);
    }
    //console.log(this.Driver);
    let driver = new this.Driver(this.driver_options);
    return await driver.save({
      files,
      path: this.driver_options.base_path
        ? `${this.driver_options.base_path}/${path}`
        : path,
    });
  }

  async download({ file, bucket, options }) {
    if (options) {
      this.driver_options = _.merge(this.driver_options, options);
    }
    let driver = new this.Driver(this.driver_options);
    return await driver.download({
      file,
      bucket,
    });
  }
}
