let fs = require('fs-extra');
var path = require('path');
var open = require("open");
let uuid = require('uuid');
import _ from 'lodash';

export default class Local{
  
    
	constructor(args={}){
        this.args = args;
    }

    async save({files, path}){
        if(_.has(files, 'path') && _.has(files, 'size') && _.has(files, '_writeStream')){
          files = {files}
        }

        files =  _.reduce(_.map(_.values(files), (file)=>{
            if(!_.isArray(file)){
              return Array.of(file)
            }
            return file;
        }), (accu, item)=>{
          return [...accu, ...item];
        }, []);

        function makeDirectory(dir) {
            if (!fs.existsSync(dir)) {
              fs.mkdirSync(dir);
            }
          }
        // Create folders 
        let pathArray = path.split('/');
        _.reduce(pathArray, (accu, item)=>{
          if(item !=  accu){
            accu = _.join([accu, item], '/'); 
          }
          makeDirectory(accu);
          return accu
        }, pathArray[0])

        // Create read stream
        const readStreams = _.map(files, (file)=>{
          return {file, readStream: fs.createReadStream(file.path)}
        });
        // Create Write Stream
        ;
        let paths = _.map(readStreams, (item)=>{
          let extension = _.last(item.file.name.split("."));
          let file_name = _.last(uuid.v4().split("-"));
          let writeStream = fs.createWriteStream(`${path}/${file_name}.${extension}`);
          item.readStream.pipe(writeStream);
          item.readStream.on("end", function (err) {
            fs.unlink(item.file.path, function (obj) { });
          });
          return `${path}/${file_name}.${extension}`;
        });

        if(paths.length==1){
          return _.first(paths);
        }
        return paths;
    }

    async delete({path}){
        console.log("Sending",this.args, path)
    }
}