"use strict";

let Rules = spice.classes.validate.Rules;

Rules.prototype.shouldExist = function* (field, value, args, message) {
  try {
    let loaded = require(spice.root_path + `/models/${args}`);
    let Class = loaded.default;
    let obj = new Class();
    let found = yield obj.exist(value);
    if (found) {
      return true;
    }
  } catch (e) {
    this.validator.addError(field, 'rule', field + 'ShouldExist', 'Cannot Validate ' + args);
  }
  return false;
}

Rules.prototype.unique = function* (field, value, args, message) {
  try {
    let loaded = require(spice.root_path + `/models/${args[0]}`);
    let Class = loaded.default;
    let obj = new Class();

    let found = yield obj.list({ query: `${args[1]} = "${value}"` });
    if (found.data.length == 0) {
      return true;
    } else {
      this.validator.addError(field, 'rule', field + ' should be unique', 'Cannot Validate ' + args[0]);
    }
  } catch (e) {
    this.validator.addError(field, 'rule', field + ' should be unique', 'Cannot Validate ' + args[0]);
  }
  return false;
}
